import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkUsersEmergency, ThinkUsersEmergencyParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询紧急联系人表
 */
export async function pageThinkUsersEmergency(
  params: ThinkUsersEmergencyParam
) {
  const res = await request.get<ApiResult<PageResult<ThinkUsersEmergency>>>(
    THINK_API_URL + '/think/think-users-emergency/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询紧急联系人表列表
 */
export async function listThinkUsersEmergency(
  params?: ThinkUsersEmergencyParam
) {
  const res = await request.get<ApiResult<ThinkUsersEmergency[]>>(
    THINK_API_URL + '/think/think-users-emergency',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加紧急联系人表
 */
export async function addThinkUsersEmergency(data: ThinkUsersEmergency) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-emergency',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改紧急联系人表
 */
export async function updateThinkUsersEmergency(data: ThinkUsersEmergency) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-emergency',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除紧急联系人表
 */
export async function removeThinkUsersEmergency(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-emergency/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除紧急联系人表
 */
export async function removeBatchThinkUsersEmergency(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-emergency/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询紧急联系人表
 */
export async function getThinkUsersEmergency(id: number) {
  const res = await request.get<ApiResult<ThinkUsersEmergency>>(
    THINK_API_URL + '/think/think-users-emergency/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
